package com.iot.farm; 

import android.app.Activity;  
import android.app.Dialog;
import android.app.ProgressDialog; 
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle; 
import android.os.Handler;
import android.view.View;
import android.view.Window; 
import android.widget.ArrayAdapter;
import android.widget.Button;  
import android.widget.ListView; 
import android.widget.Toast;
import android.view.View.OnClickListener;

public class HistoryActivity extends Activity { 


	private ListView mlist_history;
	private Button mbtn_close;
	private ArrayAdapter<String> madapter_history;

	private ProgressDialog _loading;


	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setContentView(R.layout.activity_history);

		mlist_history = (ListView) findViewById(R.id.ID_EVENT_HISTORY);

		mbtn_close = (Button) findViewById(R.id.BTN_CLOSE);

		mbtn_close.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				close();
			}
		});

		madapter_history = new ArrayAdapter<String>(this, R.layout.history_event);

		mlist_history.setAdapter(madapter_history); 

		_loading = new ProgressDialog(HistoryActivity.this);
		_loading.setProgressStyle(ProgressDialog.STYLE_SPINNER);
		_loading.setMessage(" ҷ Դϴ.");
		timerDelayRemoveDialog(Constants.DELAY_TIME, _loading);
		_loading.setCancelable(false);

		get_list_of_history();
	}

	public void timerDelayRemoveDialog(long time, final Dialog d){
		new Handler().postDelayed(new Runnable() {
			public void run() {                
				d.dismiss();   
			//	Toast.makeText(getApplicationContext(), " ҷ  ϴ.", Toast.LENGTH_SHORT).show();
			}
		}, time); 
	}

	@Override
	public synchronized void onPause() {
		super.onPause(); 
		unregisterReceiver(mBroadCastReceiver);
	}

	@Override
	public synchronized void onResume() {
		super.onResume(); 
		registerReceiver(mBroadCastReceiver, makeIntentFilter());
	}

	private void get_list_of_history()
	{ 
		timerDelayRemoveDialog(Constants.DELAY_TIME, _loading);
		_loading.show();
		madapter_history.clear();
		TCPClient.getInstance().sendMessage(IoTUtility.mkcommand_get_history()); 
	}

	private static IntentFilter makeIntentFilter() {
		final IntentFilter intentFilter = new IntentFilter();  
		intentFilter.addAction(Constants.INTENTFILTER_DATA); 
		return intentFilter;
	}

	private void close()
	{
		_loading.dismiss();
		this.finish();
	}

	private final BroadcastReceiver mBroadCastReceiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {

			final String action = intent.getAction();

			if(Constants.INTENTFILTER_DATA.equals(action))
			{
				Bundle bundle = intent.getExtras();    

				if(bundle != null) 
				{ 
					if(IoTUtility.is_get_history(bundle.getString(Constants.INTENTEXTRA_RECEIVED_DATA)))
					{
						String[] _data = IoTUtility.get_history(bundle.getString(Constants.INTENTEXTRA_RECEIVED_DATA));
						if(_data != null)
						{
							for (String _str : _data) { 
								madapter_history.add(_str); 
							}
						}
						_loading.dismiss();
					}
				}

			}

		}
	};
}
